builtin/grep: add grep.fallbackToNoIndex config
[git.git] / git-submodule.sh
blob78c2740fdb2beb48fd98c656f8ab13955cfdad56
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16 OPTIONS_SPEC=
17 SUBDIRECTORY_OK=Yes
18 . git-sh-setup
19 . git-sh-i18n
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 # Restrict ourselves to a vanilla subset of protocols; the URLs
26 # we get are under control of a remote repository, and we do not
27 # want them kicking off arbitrary git-remote-* programs.
29 # If the user has already specified a set of allowed protocols,
30 # we assume they know what they're doing and use that instead.
31 : ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32 export GIT_ALLOW_PROTOCOL
34 command=
35 branch=
36 force=
37 reference=
38 cached=
39 recursive=
40 init=
41 files=
42 remote=
43 nofetch=
44 update=
45 prefix=
46 custom_name=
47 depth=
49 # The function takes at most 2 arguments. The first argument is the
50 # URL that navigates to the submodule origin repo. When relative, this URL
51 # is relative to the superproject origin URL repo. The second up_path
52 # argument, if specified, is the relative path that navigates
53 # from the submodule working tree to the superproject working tree.
55 # The output of the function is the origin URL of the submodule.
57 # The output will either be an absolute URL or filesystem path (if the
58 # superproject origin URL is an absolute URL or filesystem path,
59 # respectively) or a relative file system path (if the superproject
60 # origin URL is a relative file system path).
62 # When the output is a relative file system path, the path is either
63 # relative to the submodule working tree, if up_path is specified, or to
64 # the superproject working tree otherwise.
65 resolve_relative_url ()
67 remote=$(get_default_remote)
68 remoteurl=$(git config "remote.$remote.url") ||
69 remoteurl=$(pwd) # the repository is its own authoritative upstream
70 url="$1"
71 remoteurl=${remoteurl%/}
72 sep=/
73 up_path="$2"
75 case "$remoteurl" in
76 *:*|/*)
77 is_relative=
79 ./*|../*)
80 is_relative=t
83 is_relative=t
84 remoteurl="./$remoteurl"
86 esac
88 while test -n "$url"
90 case "$url" in
91 ../*)
92 url="${url#../}"
93 case "$remoteurl" in
94 */*)
95 remoteurl="${remoteurl%/*}"
97 *:*)
98 remoteurl="${remoteurl%:*}"
99 sep=:
102 if test -z "$is_relative" || test "." = "$remoteurl"
103 then
104 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
105 else
106 remoteurl=.
109 esac
111 ./*)
112 url="${url#./}"
115 break;;
116 esac
117 done
118 remoteurl="$remoteurl$sep${url%/}"
119 echo "${is_relative:+${up_path}}${remoteurl#./}"
122 # Resolve a path to be relative to another path. This is intended for
123 # converting submodule paths when git-submodule is run in a subdirectory
124 # and only handles paths where the directory separator is '/'.
126 # The output is the first argument as a path relative to the second argument,
127 # which defaults to $wt_prefix if it is omitted.
128 relative_path ()
130 local target curdir result
131 target=$1
132 curdir=${2-$wt_prefix}
133 curdir=${curdir%/}
134 result=
136 while test -n "$curdir"
138 case "$target" in
139 "$curdir/"*)
140 target=${target#"$curdir"/}
141 break
143 esac
145 result="${result}../"
146 if test "$curdir" = "${curdir%/*}"
147 then
148 curdir=
149 else
150 curdir="${curdir%/*}"
152 done
154 echo "$result$target"
158 # Get submodule info for registered submodules
159 # $@ = path to limit submodule list
161 module_list()
163 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
165 git ls-files -z --error-unmatch --stage -- "$@" ||
166 echo "unmatched pathspec exists"
168 @@PERL@@ -e '
169 my %unmerged = ();
170 my ($null_sha1) = ("0" x 40);
171 my @out = ();
172 my $unmatched = 0;
173 $/ = "\0";
174 while (<STDIN>) {
175 if (/^unmatched pathspec/) {
176 $unmatched = 1;
177 next;
179 chomp;
180 my ($mode, $sha1, $stage, $path) =
181 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
182 next unless $mode eq "160000";
183 if ($stage ne "0") {
184 if (!$unmerged{$path}++) {
185 push @out, "$mode $null_sha1 U\t$path\n";
187 next;
189 push @out, "$_\n";
191 if ($unmatched) {
192 print "#unmatched\n";
193 } else {
194 print for (@out);
199 die_if_unmatched ()
201 if test "$1" = "#unmatched"
202 then
203 exit 1
208 # Print a submodule configuration setting
210 # $1 = submodule name
211 # $2 = option name
212 # $3 = default value
214 # Checks in the usual git-config places first (for overrides),
215 # otherwise it falls back on .gitmodules. This allows you to
216 # distribute project-wide defaults in .gitmodules, while still
217 # customizing individual repositories if necessary. If the option is
218 # not in .gitmodules either, print a default value.
220 get_submodule_config () {
221 name="$1"
222 option="$2"
223 default="$3"
224 value=$(git config submodule."$name"."$option")
225 if test -z "$value"
226 then
227 value=$(git config -f .gitmodules submodule."$name"."$option")
229 printf '%s' "${value:-$default}"
234 # Map submodule path to submodule name
236 # $1 = path
238 module_name()
240 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
241 sm_path="$1"
242 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
243 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
244 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
245 test -z "$name" &&
246 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
247 printf '%s\n' "$name"
251 # Clone a submodule
253 # $1 = submodule path
254 # $2 = submodule name
255 # $3 = URL to clone
256 # $4 = reference repository to reuse (empty for independent)
257 # $5 = depth argument for shallow clones (empty for deep)
259 # Prior to calling, cmd_update checks that a possibly existing
260 # path is not a git repository.
261 # Likewise, cmd_add checks that path does not exist at all,
262 # since it is the location of a new submodule.
264 module_clone()
266 sm_path=$1
267 name=$2
268 url=$3
269 reference="$4"
270 depth="$5"
271 quiet=
272 if test -n "$GIT_QUIET"
273 then
274 quiet=-q
277 gitdir=
278 gitdir_base=
279 base_name=$(dirname "$name")
281 gitdir=$(git rev-parse --git-dir)
282 gitdir_base="$gitdir/modules/$base_name"
283 gitdir="$gitdir/modules/$name"
285 if test -d "$gitdir"
286 then
287 mkdir -p "$sm_path"
288 rm -f "$gitdir/index"
289 else
290 mkdir -p "$gitdir_base"
292 clear_local_git_env
293 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
294 --separate-git-dir "$gitdir" "$url" "$sm_path"
295 ) ||
296 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
299 # We already are at the root of the work tree but cd_to_toplevel will
300 # resolve any symlinks that might be present in $PWD
301 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
302 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
303 # Remove all common leading directories after a sanity check
304 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
305 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
307 while test "${a%%/*}" = "${b%%/*}"
309 a=${a#*/}
310 b=${b#*/}
311 done
312 # Now chop off the trailing '/'s that were added in the beginning
313 a=${a%/}
314 b=${b%/}
316 # Turn each leading "*/" component into "../"
317 rel=$(printf '%s\n' "$b" | sed -e 's|[^/][^/]*|..|g')
318 printf '%s\n' "gitdir: $rel/$a" >"$sm_path/.git"
320 rel=$(printf '%s\n' "$a" | sed -e 's|[^/][^/]*|..|g')
321 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
324 isnumber()
326 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
330 # Add a new submodule to the working tree, .gitmodules and the index
332 # $@ = repo path
334 # optional branch is stored in global branch variable
336 cmd_add()
338 # parse $args after "submodule ... add".
339 reference_path=
340 while test $# -ne 0
342 case "$1" in
343 -b | --branch)
344 case "$2" in '') usage ;; esac
345 branch=$2
346 shift
348 -f | --force)
349 force=$1
351 -q|--quiet)
352 GIT_QUIET=1
354 --reference)
355 case "$2" in '') usage ;; esac
356 reference_path=$2
357 shift
359 --reference=*)
360 reference_path="${1#--reference=}"
362 --name)
363 case "$2" in '') usage ;; esac
364 custom_name=$2
365 shift
367 --depth)
368 case "$2" in '') usage ;; esac
369 depth="--depth=$2"
370 shift
372 --depth=*)
373 depth=$1
376 shift
377 break
380 usage
383 break
385 esac
386 shift
387 done
389 if test -n "$reference_path"
390 then
391 is_absolute_path "$reference_path" ||
392 reference_path="$wt_prefix$reference_path"
394 reference="--reference=$reference_path"
397 repo=$1
398 sm_path=$2
400 if test -z "$sm_path"; then
401 sm_path=$(printf '%s\n' "$repo" |
402 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
405 if test -z "$repo" || test -z "$sm_path"; then
406 usage
409 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
411 # assure repo is absolute or relative to parent
412 case "$repo" in
413 ./*|../*)
414 test -z "$wt_prefix" ||
415 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
417 # dereference source url relative to parent's url
418 realrepo=$(resolve_relative_url "$repo") || exit
420 *:*|/*)
421 # absolute url
422 realrepo=$repo
425 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
427 esac
429 # normalize path:
430 # multiple //; leading ./; /./; /../; trailing /
431 sm_path=$(printf '%s/\n' "$sm_path" |
432 sed -e '
433 s|//*|/|g
434 s|^\(\./\)*||
435 s|/\(\./\)*|/|g
436 :start
437 s|\([^/]*\)/\.\./||
438 tstart
439 s|/*$||
441 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
442 die "$(eval_gettext "'\$sm_path' already exists in the index")"
444 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
445 then
446 eval_gettextln "The following path is ignored by one of your .gitignore files:
447 \$sm_path
448 Use -f if you really want to add it." >&2
449 exit 1
452 if test -n "$custom_name"
453 then
454 sm_name="$custom_name"
455 else
456 sm_name="$sm_path"
459 # perhaps the path exists and is already a git repo, else clone it
460 if test -e "$sm_path"
461 then
462 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
463 then
464 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
465 else
466 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
469 else
470 if test -d ".git/modules/$sm_name"
471 then
472 if test -z "$force"
473 then
474 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
475 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
476 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
477 echo >&2 " $realrepo"
478 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
479 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
480 else
481 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
484 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
486 clear_local_git_env
487 cd "$sm_path" &&
488 # ash fails to wordsplit ${branch:+-b "$branch"...}
489 case "$branch" in
490 '') git checkout -f -q ;;
491 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
492 esac
493 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
495 git config submodule."$sm_name".url "$realrepo"
497 git add $force "$sm_path" ||
498 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
500 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
501 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
502 if test -n "$branch"
503 then
504 git config -f .gitmodules submodule."$sm_name".branch "$branch"
505 fi &&
506 git add --force .gitmodules ||
507 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
511 # Execute an arbitrary command sequence in each checked out
512 # submodule
514 # $@ = command to execute
516 cmd_foreach()
518 # parse $args after "submodule ... foreach".
519 while test $# -ne 0
521 case "$1" in
522 -q|--quiet)
523 GIT_QUIET=1
525 --recursive)
526 recursive=1
529 usage
532 break
534 esac
535 shift
536 done
538 toplevel=$(pwd)
540 # dup stdin so that it can be restored when running the external
541 # command in the subshell (and a recursive call to this function)
542 exec 3<&0
544 module_list |
545 while read mode sha1 stage sm_path
547 die_if_unmatched "$mode"
548 if test -e "$sm_path"/.git
549 then
550 displaypath=$(relative_path "$sm_path")
551 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
552 name=$(module_name "$sm_path")
554 prefix="$prefix$sm_path/"
555 clear_local_git_env
556 cd "$sm_path" &&
557 sm_path=$(relative_path "$sm_path") &&
558 # we make $path available to scripts ...
559 path=$sm_path &&
560 if test $# -eq 1
561 then
562 eval "$1"
563 else
564 "$@"
565 fi &&
566 if test -n "$recursive"
567 then
568 cmd_foreach "--recursive" "$@"
570 ) <&3 3<&- ||
571 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
573 done
577 # Register submodules in .git/config
579 # $@ = requested paths (default to all)
581 cmd_init()
583 # parse $args after "submodule ... init".
584 while test $# -ne 0
586 case "$1" in
587 -q|--quiet)
588 GIT_QUIET=1
591 shift
592 break
595 usage
598 break
600 esac
601 shift
602 done
604 module_list "$@" |
605 while read mode sha1 stage sm_path
607 die_if_unmatched "$mode"
608 name=$(module_name "$sm_path") || exit
610 displaypath=$(relative_path "$sm_path")
612 # Copy url setting when it is not set yet
613 if test -z "$(git config "submodule.$name.url")"
614 then
615 url=$(git config -f .gitmodules submodule."$name".url)
616 test -z "$url" &&
617 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
619 # Possibly a url relative to parent
620 case "$url" in
621 ./*|../*)
622 url=$(resolve_relative_url "$url") || exit
624 esac
625 git config submodule."$name".url "$url" ||
626 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
628 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
631 # Copy "update" setting when it is not set yet
632 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
633 test -n "$upd" &&
634 test -z "$(git config submodule."$name".update)"
635 then
636 case "$upd" in
637 checkout | rebase | merge | none)
638 ;; # known modes of updating
640 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
641 upd=none
643 esac
644 git config submodule."$name".update "$upd" ||
645 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
647 done
651 # Unregister submodules from .git/config and remove their work tree
653 # $@ = requested paths (use '.' to deinit all submodules)
655 cmd_deinit()
657 # parse $args after "submodule ... deinit".
658 while test $# -ne 0
660 case "$1" in
661 -f|--force)
662 force=$1
664 -q|--quiet)
665 GIT_QUIET=1
668 shift
669 break
672 usage
675 break
677 esac
678 shift
679 done
681 if test $# = 0
682 then
683 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
686 module_list "$@" |
687 while read mode sha1 stage sm_path
689 die_if_unmatched "$mode"
690 name=$(module_name "$sm_path") || exit
692 displaypath=$(relative_path "$sm_path")
694 # Remove the submodule work tree (unless the user already did it)
695 if test -d "$sm_path"
696 then
697 # Protect submodules containing a .git directory
698 if test -d "$sm_path/.git"
699 then
700 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
701 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
704 if test -z "$force"
705 then
706 git rm -qn "$sm_path" ||
707 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
709 rm -rf "$sm_path" &&
710 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
711 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
714 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
716 # Remove the .git/config entries (unless the user already did it)
717 if test -n "$(git config --get-regexp submodule."$name\.")"
718 then
719 # Remove the whole section so we have a clean state when
720 # the user later decides to init this submodule again
721 url=$(git config submodule."$name".url)
722 git config --remove-section submodule."$name" 2>/dev/null &&
723 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
725 done
729 # Update each submodule path to correct revision, using clone and checkout as needed
731 # $@ = requested paths (default to all)
733 cmd_update()
735 # parse $args after "submodule ... update".
736 while test $# -ne 0
738 case "$1" in
739 -q|--quiet)
740 GIT_QUIET=1
742 -i|--init)
743 init=1
745 --remote)
746 remote=1
748 -N|--no-fetch)
749 nofetch=1
751 -f|--force)
752 force=$1
754 -r|--rebase)
755 update="rebase"
757 --reference)
758 case "$2" in '') usage ;; esac
759 reference="--reference=$2"
760 shift
762 --reference=*)
763 reference="$1"
765 -m|--merge)
766 update="merge"
768 --recursive)
769 recursive=1
771 --checkout)
772 update="checkout"
774 --depth)
775 case "$2" in '') usage ;; esac
776 depth="--depth=$2"
777 shift
779 --depth=*)
780 depth=$1
783 shift
784 break
787 usage
790 break
792 esac
793 shift
794 done
796 if test -n "$init"
797 then
798 cmd_init "--" "$@" || return
801 cloned_modules=
802 module_list "$@" | {
803 err=
804 while read mode sha1 stage sm_path
806 die_if_unmatched "$mode"
807 if test "$stage" = U
808 then
809 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
810 continue
812 name=$(module_name "$sm_path") || exit
813 url=$(git config submodule."$name".url)
814 branch=$(get_submodule_config "$name" branch master)
815 if ! test -z "$update"
816 then
817 update_module=$update
818 else
819 update_module=$(git config submodule."$name".update)
820 if test -z "$update_module"
821 then
822 update_module="checkout"
826 displaypath=$(relative_path "$prefix$sm_path")
828 if test "$update_module" = "none"
829 then
830 echo "Skipping submodule '$displaypath'"
831 continue
834 if test -z "$url"
835 then
836 # Only mention uninitialized submodules when its
837 # path have been specified
838 test "$#" != "0" &&
839 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
840 Maybe you want to use 'update --init'?")"
841 continue
844 if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
845 then
846 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
847 cloned_modules="$cloned_modules;$name"
848 subsha1=
849 else
850 subsha1=$(clear_local_git_env; cd "$sm_path" &&
851 git rev-parse --verify HEAD) ||
852 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
855 if test -n "$remote"
856 then
857 if test -z "$nofetch"
858 then
859 # Fetch remote before determining tracking $sha1
860 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
861 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
863 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
864 sha1=$(clear_local_git_env; cd "$sm_path" &&
865 git rev-parse --verify "${remote_name}/${branch}") ||
866 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
869 if test "$subsha1" != "$sha1" || test -n "$force"
870 then
871 subforce=$force
872 # If we don't already have a -f flag and the submodule has never been checked out
873 if test -z "$subsha1" && test -z "$force"
874 then
875 subforce="-f"
878 if test -z "$nofetch"
879 then
880 # Run fetch only if $sha1 isn't present or it
881 # is not reachable from a ref.
882 (clear_local_git_env; cd "$sm_path" &&
883 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
884 test -z "$rev") || git-fetch)) ||
885 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
888 # Is this something we just cloned?
889 case ";$cloned_modules;" in
890 *";$name;"*)
891 # then there is no local change to integrate
892 update_module=checkout ;;
893 esac
895 must_die_on_failure=
896 case "$update_module" in
897 checkout)
898 command="git checkout $subforce -q"
899 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
900 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
902 rebase)
903 command="git rebase"
904 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
905 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
906 must_die_on_failure=yes
908 merge)
909 command="git merge"
910 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
911 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
912 must_die_on_failure=yes
915 command="${update_module#!}"
916 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
917 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
918 must_die_on_failure=yes
921 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
922 esac
924 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
925 then
926 say "$say_msg"
927 elif test -n "$must_die_on_failure"
928 then
929 die_with_status 2 "$die_msg"
930 else
931 err="${err};$die_msg"
932 continue
936 if test -n "$recursive"
937 then
939 prefix="$prefix$sm_path/"
940 clear_local_git_env
941 cd "$sm_path" &&
942 eval cmd_update
944 res=$?
945 if test $res -gt 0
946 then
947 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
948 if test $res -eq 1
949 then
950 err="${err};$die_msg"
951 continue
952 else
953 die_with_status $res "$die_msg"
957 done
959 if test -n "$err"
960 then
961 OIFS=$IFS
962 IFS=';'
963 for e in $err
965 if test -n "$e"
966 then
967 echo >&2 "$e"
969 done
970 IFS=$OIFS
971 exit 1
976 set_name_rev () {
977 revname=$( (
978 clear_local_git_env
979 cd "$1" && {
980 git describe "$2" 2>/dev/null ||
981 git describe --tags "$2" 2>/dev/null ||
982 git describe --contains "$2" 2>/dev/null ||
983 git describe --all --always "$2"
986 test -z "$revname" || revname=" ($revname)"
989 # Show commit summary for submodules in index or working tree
991 # If '--cached' is given, show summary between index and given commit,
992 # or between working tree and given commit
994 # $@ = [commit (default 'HEAD'),] requested paths (default all)
996 cmd_summary() {
997 summary_limit=-1
998 for_status=
999 diff_cmd=diff-index
1001 # parse $args after "submodule ... summary".
1002 while test $# -ne 0
1004 case "$1" in
1005 --cached)
1006 cached="$1"
1008 --files)
1009 files="$1"
1011 --for-status)
1012 for_status="$1"
1014 -n|--summary-limit)
1015 summary_limit="$2"
1016 isnumber "$summary_limit" || usage
1017 shift
1019 --summary-limit=*)
1020 summary_limit="${1#--summary-limit=}"
1021 isnumber "$summary_limit" || usage
1024 shift
1025 break
1028 usage
1031 break
1033 esac
1034 shift
1035 done
1037 test $summary_limit = 0 && return
1039 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
1040 then
1041 head=$rev
1042 test $# = 0 || shift
1043 elif test -z "$1" || test "$1" = "HEAD"
1044 then
1045 # before the first commit: compare with an empty tree
1046 head=$(git hash-object -w -t tree --stdin </dev/null)
1047 test -z "$1" || shift
1048 else
1049 head="HEAD"
1052 if [ -n "$files" ]
1053 then
1054 test -n "$cached" &&
1055 die "$(gettext "The --cached option cannot be used with the --files option")"
1056 diff_cmd=diff-files
1057 head=
1060 cd_to_toplevel
1061 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
1062 # Get modified modules cared by user
1063 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
1064 sane_egrep '^:([0-7]* )?160000' |
1065 while read mod_src mod_dst sha1_src sha1_dst status sm_path
1067 # Always show modules deleted or type-changed (blob<->module)
1068 if test "$status" = D || test "$status" = T
1069 then
1070 printf '%s\n' "$sm_path"
1071 continue
1073 # Respect the ignore setting for --for-status.
1074 if test -n "$for_status"
1075 then
1076 name=$(module_name "$sm_path")
1077 ignore_config=$(get_submodule_config "$name" ignore none)
1078 test $status != A && test $ignore_config = all && continue
1080 # Also show added or modified modules which are checked out
1081 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1082 printf '%s\n' "$sm_path"
1083 done
1086 test -z "$modules" && return
1088 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
1089 sane_egrep '^:([0-7]* )?160000' |
1090 cut -c2- |
1091 while read mod_src mod_dst sha1_src sha1_dst status name
1093 if test -z "$cached" &&
1094 test $sha1_dst = 0000000000000000000000000000000000000000
1095 then
1096 case "$mod_dst" in
1097 160000)
1098 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1100 100644 | 100755 | 120000)
1101 sha1_dst=$(git hash-object $name)
1103 000000)
1104 ;; # removed
1106 # unexpected type
1107 eval_gettextln "unexpected mode \$mod_dst" >&2
1108 continue ;;
1109 esac
1111 missing_src=
1112 missing_dst=
1114 test $mod_src = 160000 &&
1115 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1116 missing_src=t
1118 test $mod_dst = 160000 &&
1119 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1120 missing_dst=t
1122 display_name=$(relative_path "$name")
1124 total_commits=
1125 case "$missing_src,$missing_dst" in
1127 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1130 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1132 t,t)
1133 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1136 errmsg=
1137 total_commits=$(
1138 if test $mod_src = 160000 && test $mod_dst = 160000
1139 then
1140 range="$sha1_src...$sha1_dst"
1141 elif test $mod_src = 160000
1142 then
1143 range=$sha1_src
1144 else
1145 range=$sha1_dst
1147 GIT_DIR="$name/.git" \
1148 git rev-list --first-parent $range -- | wc -l
1150 total_commits=" ($(($total_commits + 0)))"
1152 esac
1154 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1155 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1156 if test $status = T
1157 then
1158 blob="$(gettext "blob")"
1159 submodule="$(gettext "submodule")"
1160 if test $mod_dst = 160000
1161 then
1162 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1163 else
1164 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1166 else
1167 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1169 if test -n "$errmsg"
1170 then
1171 # Don't give error msg for modification whose dst is not submodule
1172 # i.e. deleted or changed to blob
1173 test $mod_dst = 160000 && echo "$errmsg"
1174 else
1175 if test $mod_src = 160000 && test $mod_dst = 160000
1176 then
1177 limit=
1178 test $summary_limit -gt 0 && limit="-$summary_limit"
1179 GIT_DIR="$name/.git" \
1180 git log $limit --pretty='format: %m %s' \
1181 --first-parent $sha1_src...$sha1_dst
1182 elif test $mod_dst = 160000
1183 then
1184 GIT_DIR="$name/.git" \
1185 git log --pretty='format: > %s' -1 $sha1_dst
1186 else
1187 GIT_DIR="$name/.git" \
1188 git log --pretty='format: < %s' -1 $sha1_src
1190 echo
1192 echo
1193 done
1196 # List all submodules, prefixed with:
1197 # - submodule not initialized
1198 # + different revision checked out
1200 # If --cached was specified the revision in the index will be printed
1201 # instead of the currently checked out revision.
1203 # $@ = requested paths (default to all)
1205 cmd_status()
1207 # parse $args after "submodule ... status".
1208 while test $# -ne 0
1210 case "$1" in
1211 -q|--quiet)
1212 GIT_QUIET=1
1214 --cached)
1215 cached=1
1217 --recursive)
1218 recursive=1
1221 shift
1222 break
1225 usage
1228 break
1230 esac
1231 shift
1232 done
1234 module_list "$@" |
1235 while read mode sha1 stage sm_path
1237 die_if_unmatched "$mode"
1238 name=$(module_name "$sm_path") || exit
1239 url=$(git config submodule."$name".url)
1240 displaypath=$(relative_path "$prefix$sm_path")
1241 if test "$stage" = U
1242 then
1243 say "U$sha1 $displaypath"
1244 continue
1246 if test -z "$url" ||
1248 ! test -d "$sm_path"/.git &&
1249 ! test -f "$sm_path"/.git
1251 then
1252 say "-$sha1 $displaypath"
1253 continue;
1255 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1256 then
1257 set_name_rev "$sm_path" "$sha1"
1258 say " $sha1 $displaypath$revname"
1259 else
1260 if test -z "$cached"
1261 then
1262 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1264 set_name_rev "$sm_path" "$sha1"
1265 say "+$sha1 $displaypath$revname"
1268 if test -n "$recursive"
1269 then
1271 prefix="$displaypath/"
1272 clear_local_git_env
1273 cd "$sm_path" &&
1274 eval cmd_status
1275 ) ||
1276 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1278 done
1281 # Sync remote urls for submodules
1282 # This makes the value for remote.$remote.url match the value
1283 # specified in .gitmodules.
1285 cmd_sync()
1287 while test $# -ne 0
1289 case "$1" in
1290 -q|--quiet)
1291 GIT_QUIET=1
1292 shift
1294 --recursive)
1295 recursive=1
1296 shift
1299 shift
1300 break
1303 usage
1306 break
1308 esac
1309 done
1310 cd_to_toplevel
1311 module_list "$@" |
1312 while read mode sha1 stage sm_path
1314 die_if_unmatched "$mode"
1315 name=$(module_name "$sm_path")
1316 url=$(git config -f .gitmodules --get submodule."$name".url)
1318 # Possibly a url relative to parent
1319 case "$url" in
1320 ./*|../*)
1321 # rewrite foo/bar as ../.. to find path from
1322 # submodule work tree to superproject work tree
1323 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1324 # guarantee a trailing /
1325 up_path=${up_path%/}/ &&
1326 # path from submodule work tree to submodule origin repo
1327 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1328 # path from superproject work tree to submodule origin repo
1329 super_config_url=$(resolve_relative_url "$url") || exit
1332 sub_origin_url="$url"
1333 super_config_url="$url"
1335 esac
1337 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1338 then
1339 displaypath=$(relative_path "$prefix$sm_path")
1340 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1341 git config submodule."$name".url "$super_config_url"
1343 if test -e "$sm_path"/.git
1344 then
1346 clear_local_git_env
1347 cd "$sm_path"
1348 remote=$(get_default_remote)
1349 git config remote."$remote".url "$sub_origin_url"
1351 if test -n "$recursive"
1352 then
1353 prefix="$prefix$sm_path/"
1354 eval cmd_sync
1359 done
1362 # This loop parses the command line arguments to find the
1363 # subcommand name to dispatch. Parsing of the subcommand specific
1364 # options are primarily done by the subcommand implementations.
1365 # Subcommand specific options such as --branch and --cached are
1366 # parsed here as well, for backward compatibility.
1368 while test $# != 0 && test -z "$command"
1370 case "$1" in
1371 add | foreach | init | deinit | update | status | summary | sync)
1372 command=$1
1374 -q|--quiet)
1375 GIT_QUIET=1
1377 -b|--branch)
1378 case "$2" in
1380 usage
1382 esac
1383 branch="$2"; shift
1385 --cached)
1386 cached="$1"
1389 break
1392 usage
1395 break
1397 esac
1398 shift
1399 done
1401 # No command word defaults to "status"
1402 if test -z "$command"
1403 then
1404 if test $# = 0
1405 then
1406 command=status
1407 else
1408 usage
1412 # "-b branch" is accepted only by "add"
1413 if test -n "$branch" && test "$command" != add
1414 then
1415 usage
1418 # "--cached" is accepted only by "status" and "summary"
1419 if test -n "$cached" && test "$command" != status && test "$command" != summary
1420 then
1421 usage
1424 "cmd_$command" "$@"